/*

@echo off
cls
echo.
echo This INSTALL routine requires OS/2 REXX support installed.
echo Run Selective Installation from the OS/2 Setup Folder to
echo install REXX support before attempting to run this CMD file.
pause
exit

       *---------------------------------------------------------------*
       |                                                               |
       | Azureus 2.5.0.4 for eComStation (eCS) and OS/2 install script |
       |                                                               |
       |          INSTOS2.CMD - Install procedure for                  |
       |                        Azureus 2.5.0.4 plus SWTSwing          |
       |                                                               |
       |    Based on the Java Movie Database (JMDB) install script!    |
       |                                                               |
       |              (C)Copyright 2007 Juergen Ulbts                  |
       |              All Rights Reserved                              |
       |                                                               |
       *---------------------------------------------------------------*
*/

PARSE ARG arg '[' WarpIN ']'

'@echo off'

BootDrive             = ''
AppInstallPath        = directory()
JavaEXEString         = 'JAVA.EXE'
searchJavaString01    = 'JAVA'
JDKInstallPath        = ''
AppIcon              = AppInstallPath||'\azureus_os2_40x40.ico'
AppIcon2              = AppInstallPath||'\azureus_os2_40x40.ico'
AppName               = 'Azureus v2.5.0.4 plus SWTSwing'
ErrorCodeJAVA         = 0     /* ErrorCodes: 11=Java not found,...  */

CopyrightLine1  = 'eComStation (eCS) and OS/2 install script for the Azureus V2.5.0.4'
CopyrightLine2  = '(C) Copyright 2007 - Juergen Ulbts'
CopyrightLine3  = 'All Rights Reserved'
CopyrightLine4  = 'Provided AS IS without any warranty!!!'
CopyrightLine5  = 'The latest version can be found at: http://www.juergen-ulbts.de/swtswing'

/* Load REXXUTIL */
call rxfuncadd sysloadfuncs, rexxutil, sysloadfuncs
call sysloadfuncs


AvailDrives = SysDriveMap('C:', 'LOCAL')

/* Get boot drive letter */
done = 0
do while \ done
  IF WarpIN >< "WarpIN" then call ShowScriptCopyright
  BootDrive=GetBootDrive()
  done = 1
end

/* get the name of the Java version that has to be added to the startup script */
call getJavaVersion
if ErrorCodeJAVA = 0 then
  if JDKInstallPath='' then ErrorCodeJAVA = 11


/* Check if this is an automatically called script... */
if WarpIN = "WarpIN" then do
   call CreateSTARTOS2CMD_NOOUTPUT
   EXIT
end /* do */




/* --------------- */
if (ErrorCodeJAVA=0) then
	do forever   /* main selection loop */
		call ShowScriptCopyright
		say 'Select one of the following:'
		say
		say '  0. Exit '||AppName||' install'
		say '  1. Create '||AppName||' Desktop objects (incl startos2*.cmd)'
		say '  2. Create '||AppName||' "startos2*.cmd" only'
		say
		say '  ESC to quit'
		say
		call charout, 'Press 0,1,2 or ESC: '
		do forever 
			k = translate(SysGetKey('NOECHO'))
			if k = '0' | k = D2C(27) then
				call InstallEnd
			else do
				if k = '1' then do
					call CreatePMObjects
					leave
				end
			
				if k = '2' then do
					call CreateSTARTOS2CMD
					leave
				end
			end
			call beep 1760, 50
		end 
	end /* do forever */
/* --------------- */

Select

   when ErrorCodeJRE=11 then do
        say 'ERROR 11: Java Runtime not found! You have to manually update the CMD file!'
        say
        call PressAnyKey
        call InstallEnd
   end /* do */
        
   otherwise
        call InstallEnd
end  /* select */




/* ===================================== */
/*  ADDITIONAL PROCEDURES AND FUNCTIONS  */
/* ===================================== */


/* Create PM Objects on Desktop */
CreatePMObjects:
  call ShowScriptCopyright
  say
  call CreateSTARTOS2CMD_NOOUTPUT

  if SysCreateObject("WPFolder","Azureus","<WP_DESKTOP>", "OBJECTID=<Azureus_Folder>;ICONFILE="AppIcon2";ICONNFILE=1,"AppIcon2";", "R") Then Do
    if SysCreateObject("WPProgram", "Azureus",               "<Azureus_Folder>",  "EXENAME="AppInstallPath"\STARTOS2.CMD;STARTUPDIR="AppInstallPath";ICONFILE="AppIcon, "R") then 
      if SysCreateObject("WPProgram", "Azureus Debug",    "<Azureus_Folder>",  "EXENAME="AppInstallPath"\STARTOS2DEBUG.CMD;STARTUPDIR="AppInstallPath";ICONFILE="AppIcon, "R") then 
        if SysCreateObject("WPUrl", "Azureus4eCS Setup Guide", "<Azureus_Folder>","NOTDEFAULTICON=YES;DEFAULTVIEW=CONTENTS;URL=file:///"translate(translate(AppInstallPath||"/Azureus4eCS","|",":"), "/", "\")"/index.html;", "R") then
          if SysCreateObject("WPProgram", "Azureus Readme", "<Azureus_Folder>", "EXENAME=e.exe;PARAMETERS=Azureus4eCS_Readme.txt;STARTUPDIR="AppInstallPath";", "R") then
            if SysCreateObject("WPProgram", "Azureus History", "<Azureus_Folder>", "EXENAME=e.exe;PARAMETERS=Azureus4eCS_History.txt;STARTUPDIR="AppInstallPath";", "R") then
              if SysCreateObject("WPProgram", "Azureus Bugs", "<Azureus_Folder>", "EXENAME=e.exe;PARAMETERS=Azureus4eCS_Bugs.txt;STARTUPDIR="AppInstallPath";", "R") then
                if SysCreateObject("WPProgram", "Azureus Error Log", "<Azureus_Folder>", "EXENAME=epm.exe;PARAMETERS=error.log;STARTUPDIR="AppInstallPath";", "R") then
                say 'All objects were created!'
              Else say 'Failed to create Azureus bugs object!'
            Else say 'Failed to create Azureus history object!'
          Else say 'Failed to create Azureus readme object!'
        Else say 'Failed to create Azureus4eCS Setup Guide URL object!'
      Else say 'Failed to create Azureus Debug program object!'
    Else say 'Failed to create Azureus program object!'
  Else say 'Failed to create Azureus folder on the desktop! No other objects were created!'




  if SysCreateObject("WPFolder","Additional Links","<Azureus_Folder>", "OBJECTID=<Azureus_Links>", "R") Then Do
    if SysCreateObject("WPUrl", "Azureus project", "<Azureus_Links>","NOTDEFAULTICON=YES;DEFAULTVIEW=CONTENTS;URL=http://azureus.sf.net/;", "R") then
      if SysCreateObject("WPUrl", "SWTSwing project", "<Azureus_Links>","NOTDEFAULTICON=YES;DEFAULTVIEW=CONTENTS;URL=http://swtswing.sf.net/;", "R") then
           if SysCreateObject("WPUrl", "Homepage of Juergen Ulbts (package creator)", "<Azureus_Links>","NOTDEFAULTICON=YES;DEFAULTVIEW=CONTENTS;URL=http://www.juergen-ulbts.de/swtswing;", "R") then
           say 'All additional LINKS were created!'
      Else say 'Failed to create SWTSwing URL object!'
    Else say 'Failed to create Azureus URL object!'
  Else say 'Failed to create additional LINKS folder on the desktop! No additional URL objects were created!'

  call PressAnyKey
  return




/* Create startos2.cmd */
CreateSTARTOS2CMD:
  call ShowScriptCopyright
  say
  startfile = 'startos2.cmd'
  '@del 'startfile' >nul 2>>&1'
  rc = lineout(startfile, "@ECHO OFF")
  rc = lineout(startfile, "mode 102,80")
  rc = lineout(startfile, "REM java.exe -Xmx256M  -Dswt.swing.lightpopups=true -jar Azureus_mod.jar >error.log 2>&1 &")
  rc = lineout(startfile, "REM c:\java141\jre\bin\java.exe -Xmx256M  -Dswt.swing.lightpopups=true -cp %CLASSPATH%;retroweaver-rt-2.0.jar;SWTSwing.jar;Azureus2_mod.jar -jar Azureus2_mod.jar")
  rc = lineout(startfile, "REM >error.log 2>&1 &")
  rc = lineout(startfile, "")
  rc = lineout(startfile, "REM Azureus with buildin SWT...")
  rc = lineout(startfile, "REM ===========================")
  rc = lineout(startfile, "REM You may have to add the path to the Java141 or Java142 runtime manually ('x:\java1xx\bin\jre\java.exe -cp ...')!")
  rc = lineout(startfile, JDKInstallPath||"JAVAW.EXE -Xmx256M  -Dswt.swing.lightpopups=true -Dswt.swing.laf=com.lipstikLF.LipstikLookAndFeel"||" -cp SWTSwing.jar;retroweaver-rt-2.0.jar;Azureus2_mod2.jar;lipstikLF.jar;looks-2.0.4.jar;nimrodlf-0.98b.JAR;substance.jar;synthetica.jar;toniclf.jar org.eclipse.swt.widgets.Display org.gudy.azureus2.ui.common.Main >error.log 2>&1 &") */
  rc = lineout(startfile, "")
  rc = lineout(startfile, "REM LookAndFeels to test")
  rc = lineout(startfile, "REM ====================")
  rc = lineout(startfile, "REM Base parameter: -Dswt.swing.laf=<look and feel class to load>")
  rc = lineout(startfile, "REM")
  rc = lineout(startfile, "REM com.jgoodies.looks.plastic.PlasticXPLookAndFeel")
  rc = lineout(startfile, "REM com.lipstikLF.LipstikLookAndFeel")
  rc = lineout(startfile, "REM com.nilo.plaf.nimrod.NimRODLookAndFeel")

  say 'STARTOS2.CMD created.'

  startfile = 'startos2debug.cmd'
  '@del 'startfile' >nul 2>>&1'
  rc = lineout(startfile, "@ECHO OFF")
  rc = lineout(startfile, "mode 102,80")
  rc = lineout(startfile, "REM java.exe -Xmx256M  -Dswt.swing.lightpopups=true -jar Azureus_mod.jar >error.log 2>&1 &")
  rc = lineout(startfile, "REM c:\java141\jre\bin\java.exe -Xmx256M  -Dswt.swing.lightpopups=true -cp %CLASSPATH%;retroweaver-rt-2.0.jar;SWTSwing.jar;Azureus2_mod.jar -jar Azureus2_mod.jar")
  rc = lineout(startfile, "REM >error.log 2>&1 &")
  rc = lineout(startfile, "")
  rc = lineout(startfile, "REM Azureus with buildin SWT...")
  rc = lineout(startfile, "REM ===========================")
  rc = lineout(startfile, "REM You may have to add the path to the Java141 or Java142 runtime manually ('x:\java1xx\bin\jre\java.exe -cp ...')!")
  rc = lineout(startfile, JDKInstallPath||"JAVA.EXE -Xmx256M  -Dswt.swing.lightpopups=true -Dswt.swing.laf=com.lipstikLF.LipstikLookAndFeel"||" -cp SWTSwing.jar;retroweaver-rt-2.0.jar;Azureus2_mod2.jar;lipstikLF.jar;looks-2.0.4.jar;nimrodlf-0.98b.JAR;substance.jar;synthetica.jar;toniclf.jar org.eclipse.swt.widgets.Display org.gudy.azureus2.ui.common.Main >error.log 2>&1 &")
  rc = lineout(startfile, "")
  rc = lineout(startfile, "REM LookAndFeels to test")
  rc = lineout(startfile, "REM ====================")
  rc = lineout(startfile, "REM Base parameter: -Dswt.swing.laf=<look and feel class to load>")
  rc = lineout(startfile, "REM")
  rc = lineout(startfile, "REM com.jgoodies.looks.plastic.PlasticXPLookAndFeel")
  rc = lineout(startfile, "REM com.lipstikLF.LipstikLookAndFeel")
  rc = lineout(startfile, "REM com.nilo.plaf.nimrod.NimRODLookAndFeel")

  say 'STARTOS2DEBUG.CMD created.'

  call PressAnyKey
  return


/* Create startos2.cmd without screen output */
CreateSTARTOS2CMD_NOOUTPUT:
  startfile = 'startos2.cmd'
  '@del 'startfile' >nul 2>>&1'
  rc = lineout(startfile, "@ECHO OFF")
  rc = lineout(startfile, "mode 102,80")
  rc = lineout(startfile, "REM java.exe -Xmx256M  -Dswt.swing.lightpopups=true -jar Azureus_mod.jar >error.log 2>&1 &")
  rc = lineout(startfile, "REM c:\java141\jre\bin\java.exe -Xmx256M  -Dswt.swing.lightpopups=true -cp %CLASSPATH%;retroweaver-rt-2.0.jar;SWTSwing.jar;Azureus2_mod.jar -jar Azureus2_mod.jar")
  rc = lineout(startfile, "REM >error.log 2>&1 &")
  rc = lineout(startfile, "")
  rc = lineout(startfile, "REM Azureus with buildin SWT...")
  rc = lineout(startfile, "REM ===========================")
  rc = lineout(startfile, "REM You may have to add the path to the Java141 or Java142 runtime manually ('x:\java1xx\bin\jre\java.exe -cp ...')!")
  rc = lineout(startfile, JDKInstallPath||"JAVAW.EXE -Xmx256M  -Dswt.swing.lightpopups=true -Dswt.swing.laf=com.lipstikLF.LipstikLookAndFeel"||" -cp SWTSwing.jar;retroweaver-rt-2.0.jar;Azureus2_mod2.jar;lipstikLF.jar;looks-2.0.4.jar;nimrodlf-0.98b.JAR;substance.jar;synthetica.jar;toniclf.jar org.eclipse.swt.widgets.Display org.gudy.azureus2.ui.common.Main >error.log 2>&1 &")
  rc = lineout(startfile, "")
  rc = lineout(startfile, "REM LookAndFeels to test")
  rc = lineout(startfile, "REM ====================")
  rc = lineout(startfile, "REM Base parameter: -Dswt.swing.laf=<look and feel class to load>")
  rc = lineout(startfile, "REM")
  rc = lineout(startfile, "REM com.jgoodies.looks.plastic.PlasticXPLookAndFeel")
  rc = lineout(startfile, "REM com.lipstikLF.LipstikLookAndFeel")
  rc = lineout(startfile, "REM com.nilo.plaf.nimrod.NimRODLookAndFeel")
  
  startfile = 'startos2debug.cmd'
  '@del 'startfile' >nul 2>>&1'
  rc = lineout(startfile, "@ECHO OFF")
  rc = lineout(startfile, "mode 102,80")
  rc = lineout(startfile, "REM java.exe -Xmx256M  -Dswt.swing.lightpopups=true -jar Azureus_mod.jar >error.log 2>&1 &")
  rc = lineout(startfile, "REM c:\java141\jre\bin\java.exe -Xmx256M  -Dswt.swing.lightpopups=true -cp %CLASSPATH%;retroweaver-rt-2.0.jar;SWTSwing.jar;Azureus2_mod.jar -jar Azureus2_mod.jar")
  rc = lineout(startfile, "REM >error.log 2>&1 &")
  rc = lineout(startfile, "")
  rc = lineout(startfile, "REM Azureus with buildin SWT...")
  rc = lineout(startfile, "REM ===========================")
  rc = lineout(startfile, "REM You may have to add the path to the Java141 or Java142 runtime manually ('x:\java1xx\bin\jre\java.exe -cp ...')!")
  rc = lineout(startfile, JDKInstallPath||"JAVA.EXE -Xmx256M  -Dswt.swing.lightpopups=true -Dswt.swing.laf=com.lipstikLF.LipstikLookAndFeel"||" -cp SWTSwing.jar;retroweaver-rt-2.0.jar;Azureus2_mod2.jar;lipstikLF.jar;looks-2.0.4.jar;nimrodlf-0.98b.JAR;substance.jar;synthetica.jar;toniclf.jar org.eclipse.swt.widgets.Display org.gudy.azureus2.ui.common.Main >error.log 2>&1 &")
  rc = lineout(startfile, "")
  rc = lineout(startfile, "REM LookAndFeels to test")
  rc = lineout(startfile, "REM ====================")
  rc = lineout(startfile, "REM Base parameter: -Dswt.swing.laf=<look and feel class to load>")
  rc = lineout(startfile, "REM")
  rc = lineout(startfile, "REM com.jgoodies.looks.plastic.PlasticXPLookAndFeel")
  rc = lineout(startfile, "REM com.lipstikLF.LipstikLookAndFeel")
  rc = lineout(startfile, "REM com.nilo.plaf.nimrod.NimRODLookAndFeel")
  
  return


/* Show script copyright notice */
ShowScriptCopyright:
  call SysCls
  say
  say
  say CopyrightLine1
  say CopyrightLine2
  say CopyrightLine3
  say
  say CopyrightLine4
  say CopyrightLine5
  say
  say
  return


/* Get installed JAVA version from system */
getJavaVersion:
   /* Check INI-Files for Innotek Java */
   otherJavaInstVersion = SysIni(,'OS2 Kit for Java','CurrentVersion')
   otherJavaInstPath = SysInI(,'OS2 Kit for Java',otherJavaInstVersion)

/*
say 'JavaInstVersion = '||otherJavaInstVersion
say 'JavaInstPath    = '||otherJavaInstPath
*/

   if otherJavaInstPath = "ERROR:" then do
      otherJavaInstVersion = SysIni(,'OS2 Kit for Java SDK','CurrentVersion')
      otherJavaInstPath = SysInI(,'OS2 Kit for Java SDK',otherJavaInstVersion)
      if otherJavaInstPath = "ERROR:" then
         do
            otherJavaInstVersion = 0
            JDKInstallPath=''
         end /* do */
      else
         do
            /* iniJavaInstVersion = TRANSLATE(otherJavaInstVersion,'.','') */
            JDKInstallPath = otherJavaInstPath
         end /* do */
   end /* do */
   else do
      /* iniJavaInstVersion = TRANSLATE(otherJavaInstVersion,'.','') */
      JDKInstallPath=otherJavaInstPath
   end /* if..else do..end */

/*
  CRAP = SUBSTR(JDKInstallPath, LENGTH(JDKInstallPath), 1)
  say 'Crap='||CRAP
*/
  if LENGTH(JDKInstallPath)>0 then do
     JDKInstallPath=STRIP(JDKInstallPath,,SUBSTR(JDKInstallPath, LENGTH(JDKInstallPath), 1))
     JDKInstallPath=JDKInstallPath||'\bin\'
  end /* do */
     
  
  /* DEBUG */
/*  say 'Java EXE Path: '||JDKInstallPath */
  
  return JDKInstallPath
/* END GetJavaVersion */






/* Wait for a key press */
PressAnyKey:
  call charout, 'Press any key to continue...'
  call SysGetKey 'NOECHO'
  return



/* Get path from user */
GetPath:
  call charout, '> '
  parse pull APath
  len = length(APath)
  if len > 0 then
    if substr(APath, len, 1) = '\' then
      APath = substr(APath, 1, len-1)
  return APath




/*
GetBootDrive
   Use SysBootDrive (RexxUtils) if it is available, use RxBootDrive
   (RxExtras) if it is available, or use an alternate method to get the
   value if neither is available.  Uncomment following if GetBootDrive
   is imbedded in a routine.
*/

/* Get Bootdrive */
GetBootDrive: Procedure
If \Rxfuncquery('SysBootDrive') Then
   bootdrive = SysBootDrive()       /* Object or Updated Classic Rexx */
Else
   Do
      If \Rxfuncquery('RxBootDrive') Then
         bootdrive = RxBootDrive()                        /* RxExtras */
      Else
         Do                       /* Examine various config.sys items */
            Parse Upper Value Value('PATH', ,'OS2ENVIRONMENT') ,
               With ':\OS2\SYSTEM' - 1 bootdrive + 2
            If bootdrive = '' Then
               bootdrive = ,
               Substr(Value('RUNWORKPLACE', ,'OS2ENVIRONMENT'), 1, 2 )
            If bootdrive = '' Then
               bootdrive = ,
               Substr(Value('COMSPEC', ,'OS2ENVIRONMENT'), 1, 2)
            If bootdrive = '' Then
               bootdrive = ,
               Substr(Value('OS2_SHELL', ,'OS2ENVIRONMENT'), 1, 2)
            If bootdrive = '' Then
               bootdrive = ,
               Substr(Value('SYSTEM_INI', ,'OS2ENVIRONMENT'), 1, 2)
            If bootdrive = '' Then
               bootdrive = ,
               Substr(Value('USER_INI', ,'OS2ENVIRONMENT'), 1, 2)
            If bootdrive = '' Then                      /* no guesses */
               bootdrive = 0
         End
   End
Return bootdrive               /* Returns BootDrive, letter and colon */



/* End message */
InstallEnd:
  call SysCls
  say
  say
  say ''||AppName||' INSTALL ended.'
  exit

